这些代码用来将代码运行模式切换到保护模式。

```asm
    cli              ; 1. 禁用中断，防止在切换模式过程中出现中断请求
    lgdt [gdt_descriptor]   ; 2. 加载 GDT 描述符到 GDTR 寄存器，准备好全局描述符表
```

禁用中断后，加载gdt全局描述符表，这个表中的gdt描述符用于描述什么代码在什么地址，可以区分内核代码和用户代码。

```asm
    mov eax, cr0            ; 3. 将控制寄存器 CR0 的值加载到 EAX 寄存器
    or eax, 0x1             ; 4. 将 EAX 寄存器的第 0 位设置为 1，用于启用保护模式
    mov cr0, eax            ; 5. 将修改后的值写回 CR0，正式启用保护模式
```

上面这些代码就做了一件事，将一个指示位由关(0)变为开(1)。由于不能直接对控制寄存器进行修改，因此我们只能先存到一个通用寄存器中，再进行修改，修改后传回。

启用保护模式之后，我们可以正式加载内核代码了。

