我们在进行汇编编程时，很多时候会涉及到和特定硬件打交道，需要中断帮我们实现。

### 一点通用结构

经过一些观察，我们得到了下面这种实用的结构：

```asm

[名字]:
    pusha

    ...
    int xxxx
    ...

    popa

```

具体的作用是，pusha和popa成对，用于保存和恢复在cpu执行这个函数之前的现场：将ax,bx,cx等寄存器的值存到栈中，为这个函数中要用到这些寄存器的地方留出空间。(有点像mc绘制时调用的pushMatrix和popMatrix, 也是为了保存之前绘制的现场，让渲染器在绘制某个物体时不受到其他绘制状态的影响，也不影响结束后其他物体的继续正常绘制)
有些中断调用还对特定的寄存器有要求，例如硬盘中断就要求了在发起中断之前，对应的寄存器应该存储什么东西。

### 什么时候使用push/pop?

- 当我们进入需要特定寄存器是特定值的调用时(如磁盘中断，需要ch存储柱面, cl存储扇区), 而又不能影响到其他使用这几个寄存器的指令状态

其实一个比较好的实践是，只要调用中涉及到寄存器，都最好先保存现场再复原
