# 记录文件 - 项目各部分运行流程

## 启动流程
mbr.asm -> 打印加载信息 -> 设置加载内核 -> 从磁盘加载内核 -> 切换到32位保护模式 -> 远跳转: 初始化堆栈 -> 启动内核

## 中断机制初始化流程
(内核启动后) -> isr_install初始化中断门 -> 加载idt表 -> 启用外部中断

## 文件系统初始化流程
检查硬盘是否正常(已连接且未被占用) -> 初始化每个扇区的占用状态标记 -> 初始化根目录表

## 通用中断处理初始化流程
设置中断向量表 -> 为每个中断分配一段asm处理代码 -> 跳转到通用处理isr_common_stub -> 调用对应的handler

## 键盘初始化流程
初始化键盘中断 -> 指示键盘在产生中断时调用的函数

## 字符输入流程
键盘按下 -> 触发中断回调 -> 从键盘输入数据端口获得数据 -> 根据输入修改buffer -> 写入显存 -> 偏移自增

## 磁盘读写流程
### 创建新文件
指定文件名和大小 -> 写入条目记录表 -> 等待磁盘空闲 -> 指定各项写入参数 -> 等待数据准备完成 -> 写入数据 -> 释放磁盘占用

### 写入文件（类似创建新文件）
指定文件名和写入内容 -> 从条目记录表中获取要写入的扇区 -> 等待磁盘空闲 -> 指定各项写入参数 -> 等待数据准备完成 -> 写入数据 -> 释放磁盘占用

### 读取文件
指定文件名，准备好获取数据的buffer -> 从条目记录表中获取要读取的扇区 -> 等待磁盘空闲 -> 指定各项读取参数 -> 等待数据准备完成 -> 读取数据 -> 释放磁盘占用

## 指令处理流程
创建指令 -> 分析buffer跳转到对应执行的指令 -> 指令具体内容